
#ifndef KOMA_INF_H
#define KOMA_INF_H 1


/** 駒種.
    WALL, SFU..SOU, EFU..EOU の値をとる */
typedef unsigned char KomaInf;

/** 先手の駒につける目印 (1ビット) */
#define SELF (1 << 4)    // 名前がおかしい
#define SENTE (1 << 4)

/** 後手の駒につける目印 (1ビット) */
#define ENEMY (1 << 5)   // 名前がおかしい
#define GOTE (1 << 5)


enum {
  // 何もないところ
  EMPTY=0,
  EMP=0,			// ３文字も準備しておくとソースが見やすいので（笑）
  // 成り駒につける目印（１ビット）
  PROMOTED=1<<3,

  // 駒をあらわす数値
  FU=1,
  KY=2,
  KE=3,
  GI=4,
  KI=5,
  KA=6,
  HI=7,
  OU=8,
  TO=FU+PROMOTED,
  NY=KY+PROMOTED,
  NK=KE+PROMOTED,
  NG=GI+PROMOTED,
  UM=KA+PROMOTED,
  RY=HI+PROMOTED,
	
  // 敵も味方も進めないところ（盤の外）の目印
  WALL=SELF+ENEMY,

  // 実際の駒
  SFU=SELF+FU,		//味方の歩
  STO=SELF+TO,		//味方のと金
  SKY=SELF+KY,		//味方の香車
  SNY=SELF+NY,		//味方の成り香
  SKE=SELF+3,			//味方の桂馬
  SNK=SKE+PROMOTED,	//味方の成り桂
  SGI=SELF+4,			//味方の銀
  SNG=SGI+PROMOTED,	//味方の成り銀
  SKI=SELF+5,			//味方の金
  SKA=SELF+6,			//味方の角
  SUM=SKA+PROMOTED,	//味方の馬
  SHI=SELF+7,			//味方の飛車
  SRY=SHI+PROMOTED,	//味方の龍
  SOU=SELF+8,			//味方の玉

  EFU=ENEMY+1,		//敵の歩
  ETO=EFU+PROMOTED,	//敵のと金
  EKY=ENEMY+2,		//敵の香車
  ENY=EKY+PROMOTED,	//敵の成り香
  EKE=ENEMY+3,		//敵の桂馬
  ENK=EKE+PROMOTED,	//敵の成り桂
  EGI=ENEMY+4,		//敵の銀
  ENG=EGI+PROMOTED,	//敵の成り銀
  EKI=ENEMY+5,		//敵の金
  EKA=ENEMY+6,		//敵の角
  EUM=EKA+PROMOTED,	//敵の馬
  EHI=ENEMY+7,		//敵の飛車
  ERY=EHI+PROMOTED,	//敵の龍
  EOU=ENEMY+8,		//敵の玉
};


#endif
