
#include "kyokumen.h"
#include "move_list.h"

// 7章で追加。駒組みのボーナス点を与える。
class KyokumenKomagumi: public Kyokumen 
{
public:
	static int KomagumiValue[ERY+1][16*11];
	// 攻め駒、守り駒の相手玉・自玉との相対位置による評価点
	static int SemegomaValueS[16*11][16*11];
	static int SemegomaValueE[16*11][16*11];
	static int MamorigomaValueS[16*11][16*11];
	static int MamorigomaValueE[16*11][16*11];
public:
	// 終盤度：序盤から終盤に向かって上がっていく数値。大きいほど詰みが近い（はず）
	int Shuubando[2];
	// 駒組みによるボーナス点
	int KomagumiBonus[2];
	// 攻め駒、守り駒によるボーナス点
	int SemegomaBonus[2];
	int MamorigomaBonus[2];

  /** コンストラクタ
   */
  KyokumenKomagumi(int tesu, KomaInf ban[9][9], const int Motigoma[]):
      Kyokumen(tesu, ban, Motigoma) {
    InitShuubando();
    InitBonus();
  }

	void Initialize();
	static void InitKanagomaValue();
	void InitShuubando();
	void InitBonus();
	void SenkeiInit();

  // @override
  void Move(int SorE, const Te& te);

  void narabe(int tesu,const char *t[]);

  // 今までのvalueの代わり。
  int Evaluate();
  // 8章で追加。手の評価と並び替えをする。
  void EvaluateTe(int SorE,int teNum,Te *te);
};


/** 定跡 */
class Joseki
{
	unsigned char **JosekiData;	// 定跡の棋譜データ
	int JosekiSize;		// この定跡のサイズ（棋譜が何枚あるか）
	Joseki *child;		// 定跡ファイルを複数選択した場合、子クラスが別の定跡ファイルを持っている。
public:
  // 初期化。filenamesには、,区切りで複数のファイル名を与えることが出来る。
  Joseki(char* filenames);

	// shokiは、初期局面。（駒落ちの場合などに対応するため。）
	// 現在の局面kが定跡データ内にあった場合、その局面でどんな手がどれくらいの頻度で指されたかを返す。
	// ただし、自分自身の定跡内で見つけた場合は、childまで定跡を参照はしない。
	// これにより、優先して指させたい定跡をファイルの先頭に置き、統括的な定跡を最後に置くことで、
	// ある指し方を優先しつつ、その定跡から外れた場合に大きな定跡でカバーすることが行える。
	void fromJoseki(Kyokumen &shoki,int shokiTeban,Kyokumen &k,int tesu,int &teNum,Te te[],int hindo[]); 
};


#define RETRY_MAX 9

struct TsumeVal {
	uint64 HashVal;
	uint64 Motigoma;
	int NextEntry;
	int mate;
	Te te;
};

#define TSUME_HASH_SIZE 1024*1024
#define TSUME_HASH_AND  (TSUME_HASH_SIZE-1)

class TsumeHash {
	static TsumeVal HashTbl[TSUME_HASH_SIZE];
	static uint64 FU_BIT_TBL[19];
	static uint64 KY_BIT_TBL[5];
	static uint64 KE_BIT_TBL[5];
	static uint64 GI_BIT_TBL[5];
	static const uint64 KI_BIT_TBL[5];
	static const uint64 KA_BIT_TBL[3];
	static const uint64 HI_BIT_TBL[3];
	static TsumeVal *FindFirst(uint64 KyokumenHashVal);
	static TsumeVal *FindNext(TsumeVal* Now);
	static uint64 CalcHand(int Motigoma[]);
public:
	static void Clear();
	static void Add(uint64 KyokumenHashVal,uint64 HandHashVal,int Motigoma[],int mate,Te te);
	static TsumeVal *Find(uint64 KyokumenHashVal,uint64 HandHashVal,int Motigoma[]);
	static TsumeVal *DomSearchCheckMate(uint64 KyokumenHashVal,int Motigoma[]);
	static TsumeVal *DomSearchAntiMate(uint64 KyokumenHashVal,int Motigoma[]);
};

