
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#ifdef _WINDOWS
#include <winsock2.h>
#else
#include <unistd.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#endif

#include "shogi_game.h"



#ifdef _WINDOWS
static SOCKET s;
#else 
static int s;
#endif


/** CSAサーバに接続する.
 */
int connect_to_server(const char* Server, int Port)
{
  // ソケット構築
  s = socket(PF_INET,SOCK_STREAM,0);
  if (s<0) {
    fprintf(stderr,"Can't Create Socket.\n");
    exit(1);
  }
  // 接続先サーバ名解決
  struct hostent *host=gethostbyname(Server);
  if (host==NULL) {
    fprintf(stderr,"Can't Find Server '%s'.\n",Server);
    exit(1);
  }
  // 接続（connect)
#ifdef _WINDOWS
  SOCKADDR_IN Addr;
#else
  struct sockaddr_in Addr;
#endif
  memset(&Addr, 0,sizeof(Addr));
  Addr.sin_family = AF_INET;
  Addr.sin_port = htons(Port);
  memcpy((char *)&Addr.sin_addr, (char *)host->h_addr,host->h_length);
  int rtn = connect(s, (sockaddr *)&Addr, sizeof(Addr));

  return rtn;
}


void CsaSend(const char* buf)
{
  int ret;
  int n = strlen(buf);
  printf("send:%s",buf);
  ret = send(s, buf, n, 0);
	if (ret<0) {
		fprintf(stderr,"CSASend:SOCKET ERROR:SOCK NOT OPEN?\n");
		exit(1);
	}
}


void CsaRecv(char* buf)
{
	int sum = 0,nRecv;
	char c[1];

	for (;;) {
		// 1byteずつ読み取る。'\n'が来るまで
		nRecv = recv( s, c, 1, 0);
		if ( nRecv < 0 ) {
			fprintf(stderr,"CSARecv:SOCKET ERROR:SOCK NOT OPEN?\n");
			exit(1);
		}
		buf[sum++] = c[0];
		if (c[0]=='\n') {
			break;
		}
	}
	buf[sum++]='\0';
  printf("recv: %s",buf);
}


void close_csa()
{
#ifdef _WINDOWS
  closesocket(s);
#else
  close(s);
#endif
}
