
#include "sikou.h"
#include "move_list.h"
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <algorithm>
using namespace std;



int Kyokumen::EvalMin(Te *AtackS,int NumAtackS,Te *AtackE,int NumAtackE)
{
	int v=value;
	if (NumAtackE>0) {
		int k=0;
		while(!IsCorrectMove(AtackE[k]) && k<NumAtackE) {
			k++;
		}
		if (k==0) {
		} else if (k<NumAtackE) {
			Te t=AtackE[k];
			for(int i=k;i>0;i--) {
				AtackE[i]=AtackE[i-1];
			}
			AtackE[0]=t;
		} else {
			// 他に手がない＝取れない。
			return v;
		}
		AtackE[0].capture=ban[AtackE[0].to];
		Move(ENEMY,AtackE[0]);
		return min(v,
			EvalMax(AtackS,NumAtackS,AtackE+1,NumAtackE-1));
	} else {
		return v;
	}
}

int Kyokumen::EvalMax(Te *AtackS,int NumAtackS,Te *AtackE,int NumAtackE)
{
	int v=value;
	if (NumAtackS>0) {
		// 邪魔駒の処理
		int k=0;
		while(!IsCorrectMove(AtackS[k]) && k<NumAtackS) {
			k++;
		}
		if (k==0) {
		} else if (k<NumAtackS) {
			Te t=AtackS[k];
			for(int i=k;i>0;i--) {
				AtackS[i]=AtackS[i-1];
			}
			AtackS[0]=t;
		} else {
			// 他に手がない＝取れない。
			return v;
		}
		AtackS[0].capture=ban[AtackS[0].to];
		Move(SELF,AtackS[0]);
		return max(v,
			EvalMin(AtackS+1,NumAtackS-1,AtackE,NumAtackE));
	} else {
		return v;
	}
}
	
int Kyokumen::Eval(int position)
{
	if (ban[position]==EMPTY) {
		return 0;
	}
	if ((ban[position]&SELF) && !controlE[position]) {
		// 取られる心配がない
		return 0;
	}
	if ((ban[position]&ENEMY) && !controlS[position]) {
		// 取られる心配がない
		return 0;
	}

	int ret;
	Te teTop[40];
	int ToPos=position;

	// AtackCountを得るように、駒のリストを得る
	Te *AtackS=teTop;
	// 一個所への利きは、最大隣接8+桂馬2+飛飛角角香香香香=18だから。
	Te *AtackE=teTop+18;

	int AtackCountE=0;
	int AtackCountS=0;
	int pos2;

	int PromoteS,PromoteE;
	int b=1;
	int bj=1<<16;
	int i;
	int pos=ToPos;
	if ((ToPos&0x0f)<=3) {
		PromoteS=1;
	} else {
		PromoteS=0;
	}
	if ((ToPos&0x0f)>=7) {
		PromoteE=1;
	} else {
		PromoteE=0;
	}

	// 桂馬の利きは別に数える
	for (i = 0; i < 8; i++) {
		pos2=pos;
		if (controlS[pos] & b) {
			pos2-=Direct[i];
			AtackS[AtackCountS].from=pos2;
			AtackS[AtackCountS].koma=ban[pos2];
			AtackS[AtackCountS].to=pos;
			if ((PromoteS || (pos2 & 0x0f)<=3) && CanPromote[AtackS[AtackCountS].koma]) {
				AtackS[AtackCountS].promote=1;
			} else {
				AtackS[AtackCountS].promote=0;
			}
			AtackCountS++;
		} else if (controlE[pos] & b) {
			pos2-=Direct[i];
			AtackE[AtackCountE].from=pos2;
			AtackE[AtackCountE].koma=ban[pos2];
			AtackE[AtackCountE].to=pos;
			if ((PromoteE || (pos2 & 0x0f)>=7) && CanPromote[AtackE[AtackCountE].koma]) {
				AtackE[AtackCountE].promote=1;
			} else {
				AtackE[AtackCountE].promote=0;
			}
			AtackCountE++;
		}
		if (ban[pos-Direct[i]]!=SOU && ban[pos-Direct[i]]!=EOU) {
			while((controlS[pos2] & bj) || (controlE[pos2] & bj)) {
				pos2-=Direct[i];
				while(ban[pos2]==EMPTY) {
					pos2-=Direct[i];
				}
//				if (ban[pos2]==WALL) continue;//不要なはずなのに
				if ((ban[pos2])&ENEMY) {
					AtackE[AtackCountE].from=pos2;
					AtackE[AtackCountE].koma=ban[pos2];
					AtackE[AtackCountE].to=pos;
					if ((PromoteE || (pos2 & 0x0f)>=7) && CanPromote[AtackE[AtackCountE].koma]) {
						AtackE[AtackCountE].promote=1;
					} else {
						AtackE[AtackCountE].promote=0;
					}
					AtackCountE++;
				} else if ((ban[pos2])&SELF) {
					AtackS[AtackCountS].from=pos2;
					AtackS[AtackCountS].koma=ban[pos2];
					AtackS[AtackCountS].to=pos;
					if ((PromoteS || (pos2 & 0x0f)<=3) && CanPromote[AtackS[AtackCountS].koma]) {
						AtackS[AtackCountS].promote=1;
					} else {
						AtackS[AtackCountS].promote=0;
					}
					AtackCountS++;
				}
			}
		}
		b<<=1;
		bj<<=1;
	}
	// 桂馬の利き
	b=1<<8;
	for(i=8;i<12;i++) {
		if (controlS[pos] & b) {
			pos2=pos-Direct[i];
			AtackS[AtackCountS].from=pos2;
			AtackS[AtackCountS].koma=ban[pos2];
			AtackS[AtackCountS].to=pos;
			if (PromoteS && CanPromote[AtackS[AtackCountS].koma]) {
				AtackS[AtackCountS].promote=1;
			} else {
				AtackS[AtackCountS].promote=0;
			}
			AtackCountS++;
		}
		if (controlE[pos] & b) {
			pos2=pos-Direct[i];
			AtackE[AtackCountE].from=pos2;
			AtackE[AtackCountE].koma=ban[pos2];
			AtackE[AtackCountE].to=pos;
			if (PromoteE && CanPromote[AtackE[AtackCountE].koma]) {
				AtackE[AtackCountE].promote=1;
			} else {
				AtackE[AtackCountE].promote=0;
			}
			AtackCountE++;
		}
		b<<=1;
	}
	// 駒の価値でソート。
	for (i=0; i < AtackCountS-1; i++) {
		int max_id = i; int max_val = KomaValue[AtackS[i].koma];
		for (int j = i+1; j < AtackCountS ; j++) {
			int v=KomaValue[AtackS[j].koma];
			if (v < max_val) {
				max_id = j;
				max_val= v;
			} else if (v==max_val) {
				if (KomaValue[AtackS[j].koma]<KomaValue[AtackS[max_id].koma]) {
					max_id=j;
				}
			}
		}
		//最大値との交換
		if (i!=max_id) {
			swap(AtackS[i],AtackS[max_id]);
		}
	}
	// 駒の価値でソート。
	for (i=0; i < AtackCountE-1; i++) {
		int max_id = i; int max_val = KomaValue[AtackE[i].koma];
		for (int j = i+1; j < AtackCountE ; j++) {
			int v=KomaValue[AtackE[j].koma];
			if (v> max_val) {
				max_id = j;
				max_val= v;
			} else if (v==max_val) {
				if (KomaValue[AtackE[j].koma]>KomaValue[AtackE[max_id].koma]) {
					max_id=j;
				}
			}
		}
		//最大値との交換
		if (i!=max_id) {
			swap(AtackE[i],AtackE[max_id]);
		}
	}

	int IsEnemy=(ban[position] & ENEMY);
	int IsSelf=!IsEnemy && ban[position]!=EMPTY;
	if (IsEnemy && AtackCountS>0) {
		int Eval=value;
		Kyokumen now(*this);
		ret=now.EvalMax(AtackS,AtackCountS,AtackE,AtackCountE)-Eval;
	} else if (IsSelf && AtackCountE>0) {
		int Eval=value;
		Kyokumen now(*this);
		ret=Eval-now.EvalMin(AtackS,AtackCountS,AtackE,AtackCountE);
	} else {
		ret=0;
	}
	return ret;
}


int Kyokumen::BestEval(int SorE)
{
	// SorEの利きのある敵の駒（&SorE==0の駒）について、Evalを呼び出して、
	// 一番いい交換値を探す。
	int best=0;
	for(int suji=0x10;suji<=0x90;suji+=0x10) {
		for(int dan=1;dan<=9;dan++) {
			if ((ban[suji+dan]&SorE)==0) {
				int value=Eval(suji+dan);
				if (value>best) {
					best=value;
				}
			}
		}
	}
	if (SorE==ENEMY) return -best;
	return best;	
}


//////////////////////////////////////////////////////////////

HashEntry Sikou::HashTbl[1024 * 1024];

int Sikou::MakeMoveFirst(int SorE,int depth,Te teBuf[],KyokumenKomagumi k)
{
	int teNum=0;
	if (HashTbl[k.HashVal & 0xfffff].HashVal!=k.HashVal) {
		return 0;
	}
	if (HashTbl[k.HashVal & 0xfffff].Tesu%2!=k.Tesu%2) {
		// 手番が違う。
		return 0;
	}

	// 局面が一致したと思われる
	Te te=HashTbl[k.HashVal & 0xfffff].Best;
	if (!te.IsNull()) {
		if (k.IsLegalMove(SorE,te)) {
			teBuf[teNum++]=te;
		}
	}
	te=HashTbl[k.HashVal & 0xfffff].Second;
	if (!te.IsNull()) {
		if (k.IsLegalMove(SorE,te)) {
			teBuf[teNum++]=te;
		}
	}
	if (depth>1) {
		te=Best[depth-1][depth];
		if (!te.IsNull() && k.IsLegalMove(SorE,te)) {
			teBuf[teNum++]=te;
		}
	}
	return teNum;
}


Te Stack[32];	// 32と言う数字は適当。最大深さがこの程度までしか行かないことを期待している。

// 第４章で追加。αβ法による探索。
// 今後は、このアルゴリズムを基本に進めていく。
int Sikou::NegaAlphaBeta(int SorE,KyokumenKomagumi &k,int alpha,int beta,int depth,int depthMax,bool bITDeep)
{
	if (depth==1) {
		// 千日手チェック
		int sennitite=0;
		for(int i=k.Tesu;i>0;i-=2) {
			if (k.HashHistory[i]==k.HashVal) {
				sennitite++;
			}
		}
		if (sennitite>=4) {
			// 千日手
			sennitite=0;
			// 連続王手の千日手チェック
			int i;
			for(i=k.Tesu;sennitite<=3&&i>0;i-=2) {
				if (!Kyokumen::OuteHistory[i]) {
					break;
				}
				if (k.HashHistory[i]==k.HashVal) {
					sennitite++;
				}
			}
			if (sennitite==4) {
				// 連続王手の千日手をかけられている
				return VAL_INFINITE;
			}
			sennitite=0;
			for(i=k.Tesu;sennitite<=3&&i>1;i-=2) {
				if (!Kyokumen::OuteHistory[i-1]) {
					break;
				}
				if (k.HashHistory[i]==k.HashVal) {
					sennitite++;
				}
			}
			if (sennitite==4) {
				// 連続王手の千日手をかけている
				return -VAL_INFINITE;
			}
			return 0;
		}
	}
	if (depth==depthMax) {
		int value=k.Evaluate()+k.BestEval(SorE);
		// 自分の手番から見た得点を返す
		if (SorE==SELF) {
			return value;
		} else {
			return -value;
		}
	}
	if (HashTbl[k.HashVal & 0x0fffff].HashVal==k.HashVal) {
		HashEntry e=HashTbl[k.HashVal & 0x0fffff];
		if (e.value>=beta && e.Tesu>=k.Tesu && e.Tesu%2==k.Tesu%2 && e.depth<=depth && e.remainDepth>=depthMax-depth && e.flag!=UPPER_BOUND) {
			return e.value;
		}
		if (e.value<=alpha && e.Tesu>=k.Tesu && e.Tesu%2==k.Tesu%2 && e.depth<=depth && e.remainDepth>=depthMax-depth && e.flag!=LOWER_BOUND) {
			return e.value;
		}
	} else if (depthMax-depth>2 && bITDeep) {
		// 初めて訪れた局面で、深さも残っているので多重反復深化を行う。
		return ITDeep(SorE,k,alpha,beta,depth,depthMax);
	}
	Te teBuf[600];
	int retval=-VAL_INFINITE-1;
	if (depth<2 && k.Mate(SorE,7,teBuf[0])==1) {
		Best[depth][depth]=teBuf[0];
		Best[depth][depth+1]=Te(0);
		retval=VAL_INFINITE+1;
		goto HashAdd;
	}
	int teNum;
	if (depth==0) {
		teNum=MakeMoveFirst(SorE,depth,teBuf,k);
	} else {
		teNum=MakeMoveFirst(SorE,depth,teBuf,k);
	}
	int i;
	k.EvaluateTe(SorE,teNum,teBuf);
	for(i=0;i<teNum;i++) {
		KyokumenKomagumi kk(k);
		if (teBuf[i].IsNull()) {
			continue;
		}
		Stack[depth]=teBuf[i];
		kk.Move(SorE,teBuf[i]);
		int v=-NegaAlphaBeta(SorE==SELF?ENEMY:SELF,kk,-beta,-max(alpha,retval),depth+1,depthMax);
		// 指し手の評価がマイナスの手が直前に指されていて、それを取る手がα値を更新しないようなら、
		// 読みを深くして読み直す
		if (depth>1 && Stack[depth-1].value<0 && Stack[depth-1].to==Stack[depth].to && v<=retval) {
			v=-NegaAlphaBeta(SorE==SELF?ENEMY:SELF,kk,-beta,-max(alpha,retval),depth+1,depthMax+2);
		}
		if (v>retval) {
			retval=v;
			Best[depth][depth]=teBuf[i];
			for(int i=depth+1;i<depthMax;i++) {
				Best[depth][i]=Best[depth+1][i];
			}
			if (depth==0) {
				printf("retval:%d,te:",retval);
				for(int j=0;j<depthMax;j++) {
					Best[0][j].Print();
				}
				printf("\n");
			}
			if (retval>=beta) {
				goto HashAdd;
			}
		}
	}
	teNum=k.MakeLegalMoves(SorE,teBuf);
	if (teNum==0) {
		// 負け
		return -VAL_INFINITE;
	}
	k.EvaluateTe(SorE,teNum,teBuf);
	for(i=0;i<teNum;i++) {
		if ((teBuf[i].value<-100 || i>30) && i>0 && retval>-VAL_INFINITE) {
			break;
		}
		KyokumenKomagumi kk(k);
		Stack[depth]=teBuf[i];
		kk.Move(SorE,teBuf[i]);
		int v=-NegaAlphaBeta(SorE==SELF?ENEMY:SELF,kk,-beta,-max(alpha,retval),depth+1,depthMax);
		// 指し手の評価がマイナスの手が直前に指されていて、それを取る手がα値を更新しないようなら、
		// 読みを深くして読み直す
		if (depth>1 && Stack[depth-1].value<0 && Stack[depth-1].to==Stack[depth].to && v<=beta) {
			v=-NegaAlphaBeta(SorE==SELF?ENEMY:SELF,kk,-beta,-max(alpha,retval),depth+1,depthMax+2);
		}
		if (v>retval) {
			retval=v;
			Best[depth][depth]=teBuf[i];
			for(int i=depth+1;i<depthMax;i++) {
				Best[depth][i]=Best[depth+1][i];
			}
			if (depth==0) {
				printf("retval:%d,te:",retval);
				for(int j=0;j<depthMax;j++) {
					Best[0][j].Print();
				}
				printf("\n");
			}
			if (retval>=beta) {
				goto HashAdd;
			}
		}
	}
HashAdd:
	HashEntry e;
	e=HashTbl[k.HashVal & 0x0fffff];
	if (e.HashVal==k.HashVal) {
		e.Second=e.Best;
	} else {
		if (e.Tesu-e.depth==k.Tesu-depth && e.remainDepth>depthMax-depth) {
			// ハッシュにあるデータの方が重要なので上書きしない
			if (depth==0) {
				k.Print();
				Best[depth][depth].Print();
			}
			goto NotAdd;
		}
		e.HashVal=k.HashVal;
		e.Second=Te(0);
	}
	if (retval>alpha) {
		e.Best=Best[depth][depth];
	} else {
		e.Best=Te(0);
	}
	e.value=retval;
	if (retval<=alpha) {
		e.flag=UPPER_BOUND;
	} else if (retval>=beta) {
		e.flag=LOWER_BOUND;
	} else {
		e.flag=EXACTLY_VALUE;
	}
	e.depth=depth;
	e.remainDepth=depthMax-depth;
	e.Tesu=k.Tesu;
	HashTbl[k.HashVal & 0x0fffff]=e;
NotAdd:
	return retval;
}


int Sikou::ITDeep(int SorE,KyokumenKomagumi &k,int alpha,int beta,int depth,int depthMax)
{
	int retval;
	int i;
	for(i=depth+1;i<=depthMax;i++) {
		retval=NegaAlphaBeta(SorE,k,alpha,beta,depth,i,false);
	}
	return retval;
}

Joseki joseki("public.bin");
Kyokumen* shoki = NULL;


// 本格的に先読みをする思考ルーチンになりました。
Te Sikou::Think(int SorE,KyokumenKomagumi k)
{
	int teNum;
	Te teBuf[600];
	int hindo[600];
	int i,j;
	joseki.fromJoseki(*shoki,SELF,k,k.Tesu,teNum,teBuf,hindo);
	// 一番頻度の高い定跡を選ぶ。
	if (teNum>0) {
		int max,maxhindo;
		max=0;
		maxhindo=hindo[max];
		for(i=1;i<teNum;i++) {
			if (hindo[i]>maxhindo) {
				maxhindo=hindo[i];
				max=i;
			}
		}
		return teBuf[max];
	}
	TsumeHash::Clear();

	// depthMaxは適当に残り時間に合わせて調整するなどの工夫が必要です。
  int depthMax = 5;
	for(i=0;i<MAX_DEPTH;i++) {
		for(j=0;j<MAX_DEPTH;j++) {
			Best[i][j]=Te(0);
		}
	}
	int bestVal=ITDeep(SorE,k,-VAL_INFINITE+1,VAL_INFINITE-1,0,depthMax);
//	int bestVal=NegaAlphaBeta(SorE,k,-VAL_INFINITE+1,VAL_INFINITE-1,0,depthMax);
	printf("bestVal:%d,te:",bestVal);
	for(i=0;i<depthMax;i++) {
		Best[0][i].Print();
	}
	printf("\n");

	return Best[0][0];
}


